package de.ronnyfriedland.cassandra.wrapper

import de.ronnyfriedland.cassandra.entity.BaseEntity

/**
 * @author Ronny Friedland
 */
class EntityWrapper {

    def private static EXLUCDE_PROPERTIES = ["metaClass"]
    def private static READONLY_PROPERTIES = ["class"]

    static Map<String, Object> fromEntity(BaseEntity entity) {
        Expando ex = new Expando()
        entity?.properties?.each {
            if(!EXLUCDE_PROPERTIES.grep(it.key)) {
                ex.setProperty(it.key, it.value)
            }
        }
        ex.properties
    }

    static BaseEntity toEntity(Map<String, Object> properties) {
        def clazzProperty = properties?.get("class")
        def clazz
        if(clazzProperty instanceof Class) {
            clazz = clazzProperty.name
        } else if(clazzProperty instanceof String) {
            clazz = clazzProperty.replaceAll("class", "").trim()
        } else {
            throw new RuntimeException("Unexpected type for property 'class' !")
        }

        READONLY_PROPERTIES?.each { properties.remove(it) }

        BaseEntity entity = Class.forName(clazz).newInstance(properties)
    }
}
