package de.ronnyfriedland.cassandra.entity;

/**
 * Entity, mit dem byte-Arrays verschlüsselt abgelegt werden können.
 * 
 * @author Ronny Friedland
 */
public class SecureBaseEntity extends BaseEntity {

    private byte[] secretKey = null;

    /**
     * Erzeugt eine neue SecureBaseEntity-Instanz.
     */
    protected SecureBaseEntity() {
        super();
    }

    /**
     * Erzeugt eine neue SecureBaseEntity-Instanz.
     * 
     * @param aColumnFamily
     * @param aSecretKey
     */
    public SecureBaseEntity(final String aColumnFamily, final byte[] aSecretKey) {
        super(aColumnFamily);
        this.secretKey = aSecretKey;
    }

    public SecureBaseEntity(final String aUuid, final String aColumnFamily, final byte[] aSecretKey) {
        super(aUuid, aColumnFamily);
        this.secretKey = aSecretKey;
    }

    public byte[] getSecretKey() {
        return secretKey;
    }

    /**
     * {@inheritDoc}
     * 
     * @see de.ronnyfriedland.cassandra.entity.BaseEntity#toString()
     */
    @Override
    public String toString() {
        StringBuffer sbuf = new StringBuffer(super.toString());
        sbuf.append("[secretKey: ***]");
        return sbuf.toString();
    }
}
