package de.ronnyfriedland.cassandra.entity;

import java.util.Map;

import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import de.ronnyfriedland.cassandra.sec.SecurityUtilsTest;
import de.ronnyfriedland.cassandra.wrapper.EntityWrapper;

/**
 * Testet den {@link EntityWrapper} mit eigener Entity.
 * 
 * @author Ronny Friedland
 */
public class EntityTest {

    private static final java.util.logging.Logger LOG = java.util.logging.Logger.getLogger(SecurityUtilsTest.class
            .getName());

    @Before
    public void setUp() throws Exception {
    }

    @After
    public void tearDown() throws Exception {
    }

    @Test
    public void testProperties() {
        TestEntity entity = new TestEntity("test_cf");
        entity.setNewProperty("Cassandra NoSQL");

        Map<String, Object> map = EntityWrapper.fromEntity(entity);

        Assert.assertEquals(entity.getUuid(), map.get("uuid"));
        Assert.assertEquals(entity.getNewProperty(), map.get("newProperty"));

        TestEntity newEntity = (TestEntity) EntityWrapper.toEntity(map);
        LOG.info(newEntity.getNewProperty());
    }
}

class TestEntity extends BaseEntity {

    private String newProperty;

    public TestEntity(final String cf) {
        super(cf);
    }

    public void setNewProperty(final String newProperty) {
        this.newProperty = newProperty;
    }

    public String getNewProperty() {
        return newProperty;
    }

}
